<!DOCTYPE html>
<html>
<head>
	<title></title>
</head>
<body>
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous">
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-ygbV9kiqUc6oa4msXn9868pTtWMgiQaeYH7/t7LECLbyPA2x65Kgf80OJFdroafW" crossorigin="anonymous"></script>
	<script>
		let students = [
			{id:1,name:'Vivek', email:'vivek@abc.com', phone:'8989389333',address:"Singapore"},
			{id:2,name:'Dev', email:'dev@abc.com', phone:'866u389333',address:"India"},
			{id:3,name:'Ameer', email:'ameer@abc.com', phone:'877779333',address:"Asia"}
		]; //object
		
        const saveStudents = (students) => {
            // localStorage.setItem("key","value")
            localStorage.setItem("_students",JSON.stringify(students));
        }
        let selectedStudentId=0;
		generateNextId= ()=>{
			let numberArray = students.map(item=>{return item.id});
			console.log(numberArray);
			//spread operator
			let max = Math.max(...numberArray);
			return max +1;
		}
		if(localStorage.getItem("_students") != null){
            try {
                students = JSON.parse(localStorage.getItem("_students"))
            } catch (error) {
                
            }
        }
        
        let addUpdateStudent = () => {
			var name = document.getElementById('name').value;
			document.getElementById('name').value = '';

            var email = document.getElementById('email').value;
			document.getElementById('email').value = '';

            var phone = document.getElementById('phone').value;
			document.getElementById('phone').value = '';

            var address = document.getElementById('address').value;
			document.getElementById('address').value = '';
			
            if(document.getElementById('add').value == "Update"){
                document.getElementById('add').value="Add";
                let list = students.filter((item)=>(item.id == selectedStudentId));
                if(list.length > 0){
                    let record = list[0];
                    record.name = name;
                    record.email = email;
                    record.phone = phone;
                    record.address = address;
                }
            }else{
                var Student = {id:Date.now(), name,email,phone,address }
                customers.push(student);
            }
			saveStudents(students);
            updateGUI(students);
		}

		var updateGUI = function(students){
			//JSON.stringify(s);
			const result = document.getElementById("result"); //result is the list
			result.innerHTML = "";//make it blank
			editRecord = function(i){
					console.log(" Want to edit ",students[i]);
                    document.getElementById('name').value = students[i].name;
                    document.getElementById('email').value = students[i].email;
                    document.getElementById('phone').value = students[i].phone;
                    document.getElementById('address').value = customers[i].address;
                    document.getElementById('add').value = "Update";
                    selectedStudentId = students[i].id;
					
					updateGUI(students);
				}
			deleteRecord = function(i){
					console.log(" Want to delete "+students[i]);
					students = students.filter((item) => (item.id != students[i].id));
                    saveStudents(students);
					updateGUI(students);
				}
			for (let i = 0; i < students.length; i++ ) {
				result.innerHTML+=	`<tr>
					<th scope="row">${students[i].id}</th>
					<td>${students[i].name}</td>
					<td>${students[i].email}</td>
					<td>${students[i].phone}</td>
					<td>${students[i].address}</td>
					<td><button class="btn btn-info" onclick='editRecord(`+i+`)' >Edit</button></td>
					<td><button class="btn btn-danger" onclick='deleteRecord(`+i+`)' >Delete</button></td>
				</tr>`;
			}
		}
		let removeWord = () => {
			//how js works
			let temp = [];
			var word = document.getElementById('newWord').value;
			if(word === ""){
				words.pop();
			} else{
				students = students.filter(function(item){return (item != word)});
                saveStudents(students);
			 console.log("Assignment remove :"+word);
			}
			
			updateGUI(students);
		}
		var doSearch = () =>{
			var field = document.getElementById('field').value;
			var searchText = document.getElementById('searchText').value;
			console.log("field::"+field);
			console.log("searchText::"+searchText);
			if(searchText.length ==0){
				updateGUI(students);
			}else{
				searchText = searchText.toLowerCase();
				let temp = students.filter((item)=>(item[field].toLowerCase().startsWith(searchText)))
				updateGUI(temp);
			}
		}

	</script>
	<div style="margin-left:15px;">
	<h1> Student App</h1>
	<input id="name" placeholder="Name" type="" name="" value=""> <br/> <br/>
	<input id="email" placeholder="Email" type=""  value=""> <br/> <br/>
	<input id="phone" placeholder="Phone" type=""  value=""> <br/> <br/>
	<input id="address" placeholder="Address" type=""  value=""> <br/> <br/>

	<input id="add" onclick="addUpdateStudent()" type="button" name="" value="Add"> | 
	<input onclick="removeWord()" type="button" name="" value="Cancel"> | 
	<input onclick="sortRecords('name')" type="button" name="" value="Sort by Name"> | 
	<input onclick="sortRecords('email')" type="button" name="" value="Sort by Email"> | 
	<input onclick="sortRecords('address')" type="button" name="" value="Sort by Address"> | 
	<br/><br/>
	<input id="searchText" placeholder="Search text" name="">
	<label>Search By</label>
	<select name="field" id="field">
	  <option value="name">Name</option>
	  <option value="email">Email</option>
	  <option value="phone">Phone</option>
	  <option value="address">Address</option>
	  <option value="id">Id</option>
	</select>
	<button onclick="doSearch()">Search</button> <br/><br/>
	 <br/> <br/>
	 <h4> LISTING</h4>
	 <table  class="table">
		<thead>
			<tr>
				<th>#</th>
				<th>Name</th>
				<th>Email</th>
				<th>Phone</th>
				<th>Address</th>
				<th>Edit</th>
				<th>Delete</th>
			</tr>
		</thead>
	<tbody id="result">
	</tbody>
</table><br/><br/>
</div>
	<script type="text/javascript">
		updateGUI(students);
	</script>

</body>
</html>
